package cn.hrs.web.servlet;

import javax.imageio.ImageIO;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.awt.*;
import java.awt.image.BufferedImage;
import java.io.IOException;
import java.util.Random;

/**
 * 网页验证码
 */
@WebServlet("/checkCodeServlet")
public class CheckCodeServlet extends HttpServlet {
    @Override
    protected void doPost(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {

        int width = 100;
        int height = 50;
        //1、创建图片
        BufferedImage image = new BufferedImage(width,height,BufferedImage.TYPE_INT_RGB);
        //2、填充背景颜色
        Graphics g = image.getGraphics(); //创建画笔对象
        g.setColor(Color.PINK);           //设置画笔颜色
        g.fillRect(0,0,width,height);//填充背景
        //3、画边框
        g.setColor(Color.BLUE);
        g.drawRect(0,0,width-1,height-1);
        //4、填入验证码
        String str = "QWERTYUIOPASDFGHJKLZXCVBNMqwertyuiopasdfghjklzxcvbnm1234567890";
        StringBuilder sb = new StringBuilder();
        Random ran = new Random();
        for (int i=1;i<=4;i++){
            int index = ran.nextInt(str.length()); //生成随机的角标
            char ch = str.charAt(index);           //获取对应字符
            sb.append(ch);
            g.drawString(ch+"",width/5*i,height/2); //写入验证码
        }
        String s = sb.toString();
        req.getSession().setAttribute("checkCode_session",s);
        //5、画干扰线
        g.setColor(Color.GREEN);
        for (int i=0;i<10;i++){
            int x1 = ran.nextInt(width);
            int x2 = ran.nextInt(width);

            int y1 = ran.nextInt(height);
            int y2 = ran.nextInt(height);

            g.drawLine(x1,y1,x2,y2);
        }
        //6、将图片输出到网页上
        ImageIO.write(image,"jpg",resp.getOutputStream());
    }

    @Override
    protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        this.doPost(req,resp);
    }
}
